## libnss-cache 0.10

=== Makefile ===
CC=gcc
#CFLAGS=-Wall -Wstrict-prototypes -Werror -fPIC -DDEBUG -g -O0
CFLAGS=-Wall -Wstrict-prototypes -Werror -fPIC
LIBRARY=libnss_cache.so.2.0
LINKS=libnss_cache.so.2 libnss_cache.so
DESTDIR=/
PREFIX=$(DESTDIR)/usr
BUILD=.libs
BUILD64=.libs64
BUILD32=.libs32
LIBDIR=$(PREFIX)/lib
LIBDIR64=$(PREFIX)/lib64
LIBDIR32=$(PREFIX)/lib32
SONAME=libnss_cache.so.2
LD_SONAME=-Wl,-soname,$(SONAME)
TESTBIN=.testbin
TESTDATA=.testdata

SOURCES = Makefile gen_getent.c lookup.c nss_cache.c nss_cache.h nss_test.h COPYING
VERSION = $(shell cat version)

default: build_amd64
	echo N.B.  Defaulted to build_amd64!

test: test_getent time_lookups

time_lookups: lookup_data lookup.c nss_cache.c
	$(CC) $(CFLAGS) -o $(TESTBIN)/lookup lookup.c nss_cache.c
	@echo Linear username lookups
	rm -f $(TESTDATA)/passwd.cache.byname
	time -f %E $(TESTBIN)/lookup -c getpwnam -f $(TESTDATA)/rand_pwnames
	@echo Binary username lookups
	sort -t: -k1,1 $(TESTDATA)/passwd.cache > $(TESTDATA)/passwd.cache.byname
	time -f %E $(TESTBIN)/lookup -c getpwnam -f $(TESTDATA)/rand_pwnames
	@echo Linear UID lookups
	rm -f $(TESTDATA)/passwd.cache.byuid
	time -f %E $(TESTBIN)/lookup -c getpwuid -f $(TESTDATA)/rand_pwuids
	@echo Binary UID lookups
	sort -t: -k3,3 -n $(TESTDATA)/passwd.cache > $(TESTDATA)/passwd.cache.byuid
	time -f %E $(TESTBIN)/lookup -c getpwuid -f $(TESTDATA)/rand_pwuids
	@echo Linear groupname lookups
	rm -f $(TESTDATA)/group.cache.byname
	time -f %E $(TESTBIN)/lookup -c getgrnam -f $(TESTDATA)/rand_grnames
	@echo Binary groupname lookups
	sort -t: -k1,1 $(TESTDATA)/group.cache > $(TESTDATA)/group.cache.byname
	time -f %E $(TESTBIN)/lookup -c getgrnam -f $(TESTDATA)/rand_grnames
	@echo Linear GID lookups
	rm -f $(TESTDATA)/group.cache.bygid
	time -f %E $(TESTBIN)/lookup -c getgrgid -f $(TESTDATA)/rand_grgids
	@echo Binary GID lookups
	sort -t: -k3,3 -n $(TESTDATA)/group.cache > $(TESTDATA)/group.cache.bygid
	time -f %E $(TESTBIN)/lookup -c getgrgid -f $(TESTDATA)/rand_grgids
	@echo Linear shadow lookups
	rm -f $(TESTDATA)/shadow.cache.byname
	time -f %E $(TESTBIN)/lookup -c getspnam -f $(TESTDATA)/rand_spnames
	@echo Binary shadow lookups
	sort -t: -k1,1 $(TESTDATA)/shadow.cache > $(TESTDATA)/shadow.cache.byname
	time -f %E $(TESTBIN)/lookup -c getspnam -f $(TESTDATA)/rand_spnames

test_getent: getent_data gen_getent.c nss_cache.c
	$(CC) -o $(TESTBIN)/gen_getent gen_getent.c nss_cache.c
	./$(TESTBIN)/gen_getent
	diff $(TESTDATA)/passwd.cache $(TESTDATA)/passwd.cache.out
	diff $(TESTDATA)/group.cache $(TESTDATA)/group.cache.out
	diff $(TESTDATA)/shadow.cache $(TESTDATA)/shadow.cache.out

lookup_data: getent_data
	cut -d : -f 1 $(TESTDATA)/passwd.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_pwnames
	cut -d : -f 3 $(TESTDATA)/passwd.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_pwuids
	cut -d : -f 1 $(TESTDATA)/group.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_grnames
	cut -d : -f 3 $(TESTDATA)/group.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_grgids
	cut -d : -f 1 $(TESTDATA)/shadow.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_spnames

getent_data: testdirs
	getent passwd > $(TESTDATA)/passwd.cache
	getent group > $(TESTDATA)/group.cache
	getent shadow > $(TESTDATA)/shadow.cache

testdirs:
	mkdir -p $(TESTDATA)
	mkdir -p $(TESTBIN)

build_i386: nss_cache64

build_amd64: nss_cache32

install_i386: install64

install_amd64: install32

nss_cache:
	[ -d $(BUILD) ] || mkdir $(BUILD)
	$(CC) $(CFLAGS) -c nss_cache.c -o $(BUILD)/nss_cache.o
	$(CC) -shared $(LD_SONAME) -o $(BUILD)/$(LIBRARY) $(BUILD)/nss_cache.o

nss_cache64: nss_cache
	[ -d $(BUILD64) ] || mkdir $(BUILD64)
	$(CC) $(CFLAGS) -m64 -c nss_cache.c -o $(BUILD64)/nss_cache.o
	$(CC) -m64 -shared $(LD_SONAME) -o $(BUILD64)/$(LIBRARY) $(BUILD64)/nss_cache.o

nss_cache32: nss_cache
	[ -d $(BUILD32) ] || mkdir $(BUILD32)
	$(CC) $(CFLAGS) -m32 -c nss_cache.c -o $(BUILD32)/nss_cache.o
	$(CC) -m32 -shared $(LD_SONAME) -o $(BUILD32)/$(LIBRARY) $(BUILD32)/nss_cache.o

clean:
	rm -rf $(BUILD)
	rm -rf $(BUILD32)
	rm -rf $(BUILD64)
	rm -rf $(TESTDATA)
	rm -rf $(TESTBIN)

install:
	[ -d $(LIBDIR) ] || install -d $(LIBDIR)
	install $(BUILD)/$(LIBRARY) $(LIBDIR)
	cd $(LIBDIR); for link in $(LINKS); do ln -sf $(LIBRARY) $$link ; done

install64: install
	[ -d $(LIBDIR64) ] || install -d $(LIBDIR64)
	install $(BUILD64)/$(LIBRARY) $(LIBDIR64)
	cd $(LIBDIR64); for link in $(LINKS); do ln -sf $(LIBRARY) $$link ; done

install32: install
	[ -d $(LIBDIR32) ] || install -d $(LIBDIR32)
	install $(BUILD32)/$(LIBRARY) $(LIBDIR32)
	cd $(LIBDIR32); for link in $(LINKS); do ln -sf $(LIBRARY) $$link ; done

distclean: clean
	rm -f *~ \#*

dist:
	rm -rf libnss-cache-$(VERSION) libnss-cache-$(VERSION).tar libnss-cache-$(VERSION).tar.gz
	mkdir libnss-cache-$(VERSION)
	cp $(SOURCES) libnss-cache-$(VERSION)
	tar cf libnss-cache-$(VERSION).tar libnss-cache-$(VERSION)
	gzip -9 libnss-cache-$(VERSION).tar
	rm -rf libnss-cache-$(VERSION)

.PHONY: dist clean install install64 install32 distclean

=== debian/changelog ===
libnss-cache (0.10-2) unstable; urgency=low

  *  Remove post{inst,rm}, as dh_makeshlibs already does the ldconfig for us.

 -- Jamie Wilkinson <jaq@debian.org>  Sat, 20 Aug 2011 09:04:28 +1000

libnss-cache (0.10-1) unstable; urgency=low

  * Initial release. (Closes: #609626)

 -- Jamie Wilkinson <jaq@debian.org>  Fri, 22 Jul 2011 12:17:00 +1000

## libnss-cache 0.10.2

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 TESTBIN=.testbin
 TESTDATA=.testdata
 
-SOURCES = Makefile gen_getent.c lookup.c nss_cache.c nss_cache.h nss_test.h COPYING
+SOURCES = Makefile gen_getent.c lookup.c nss_cache.c nss_cache.h nss_test.h COPYING version libnss-cache.spec
 VERSION = $(shell cat version)
 
 default: build_amd64
@@ -27,39 +27,40 @@
 time_lookups: lookup_data lookup.c nss_cache.c
 	$(CC) $(CFLAGS) -o $(TESTBIN)/lookup lookup.c nss_cache.c
 	@echo Linear username lookups
-	rm -f $(TESTDATA)/passwd.cache.byname
+	rm -f $(TESTDATA)/passwd.cache.ixname
 	time -f %E $(TESTBIN)/lookup -c getpwnam -f $(TESTDATA)/rand_pwnames
 	@echo Binary username lookups
-	sort -t: -k1,1 $(TESTDATA)/passwd.cache > $(TESTDATA)/passwd.cache.byname
+	../vendetta/files/gen_cache.py $(TESTDATA)/passwd.cache 1 $(TESTDATA)/passwd.cache.ixname
 	time -f %E $(TESTBIN)/lookup -c getpwnam -f $(TESTDATA)/rand_pwnames
 	@echo Linear UID lookups
-	rm -f $(TESTDATA)/passwd.cache.byuid
+	rm -f $(TESTDATA)/passwd.cache.ixuid
 	time -f %E $(TESTBIN)/lookup -c getpwuid -f $(TESTDATA)/rand_pwuids
 	@echo Binary UID lookups
-	sort -t: -k3,3 -n $(TESTDATA)/passwd.cache > $(TESTDATA)/passwd.cache.byuid
+	../vendetta/files/gen_cache.py $(TESTDATA)/passwd.cache 3 $(TESTDATA)/passwd.cache.ixuid
 	time -f %E $(TESTBIN)/lookup -c getpwuid -f $(TESTDATA)/rand_pwuids
 	@echo Linear groupname lookups
-	rm -f $(TESTDATA)/group.cache.byname
+	rm -f $(TESTDATA)/group.cache.ixname
 	time -f %E $(TESTBIN)/lookup -c getgrnam -f $(TESTDATA)/rand_grnames
 	@echo Binary groupname lookups
-	sort -t: -k1,1 $(TESTDATA)/group.cache > $(TESTDATA)/group.cache.byname
+	sort -t: -k1,1 $(TESTDATA)/group.cache > $(TESTDATA)/group.cache.ixname
+	../vendetta/files/gen_cache.py $(TESTDATA)/group.cache 1 $(TESTDATA)/group.cache.ixname
 	time -f %E $(TESTBIN)/lookup -c getgrnam -f $(TESTDATA)/rand_grnames
 	@echo Linear GID lookups
-	rm -f $(TESTDATA)/group.cache.bygid
+	rm -f $(TESTDATA)/group.cache.ixgid
 	time -f %E $(TESTBIN)/lookup -c getgrgid -f $(TESTDATA)/rand_grgids
 	@echo Binary GID lookups
-	sort -t: -k3,3 -n $(TESTDATA)/group.cache > $(TESTDATA)/group.cache.bygid
+	../vendetta/files/gen_cache.py $(TESTDATA)/group.cache 3 $(TESTDATA)/group.cache.ixgid
 	time -f %E $(TESTBIN)/lookup -c getgrgid -f $(TESTDATA)/rand_grgids
 	@echo Linear shadow lookups
-	rm -f $(TESTDATA)/shadow.cache.byname
+	rm -f $(TESTDATA)/shadow.cache.ixname
 	time -f %E $(TESTBIN)/lookup -c getspnam -f $(TESTDATA)/rand_spnames
 	@echo Binary shadow lookups
-	sort -t: -k1,1 $(TESTDATA)/shadow.cache > $(TESTDATA)/shadow.cache.byname
+	../vendetta/files/gen_cache.py $(TESTDATA)/shadow.cache 1 $(TESTDATA)/shadow.cache.ixname
 	time -f %E $(TESTBIN)/lookup -c getspnam -f $(TESTDATA)/rand_spnames
 
 test_getent: getent_data gen_getent.c nss_cache.c
 	$(CC) -o $(TESTBIN)/gen_getent gen_getent.c nss_cache.c
-	./$(TESTBIN)/gen_getent
+	sudo ./$(TESTBIN)/gen_getent
 	diff $(TESTDATA)/passwd.cache $(TESTDATA)/passwd.cache.out
 	diff $(TESTDATA)/group.cache $(TESTDATA)/group.cache.out
 	diff $(TESTDATA)/shadow.cache $(TESTDATA)/shadow.cache.out
@@ -79,7 +80,7 @@
 getent_data: testdirs
 	getent passwd > $(TESTDATA)/passwd.cache
 	getent group > $(TESTDATA)/group.cache
-	getent shadow > $(TESTDATA)/shadow.cache
+	sudo getent shadow > $(TESTDATA)/shadow.cache
 
 testdirs:
 	mkdir -p $(TESTDATA)

=== debian/changelog ===
libnss-cache (0.10.2-1) unstable; urgency=low

  * New upstream release.

 -- Jamie Wilkinson <jaq@debian.org>  Fri, 10 Feb 2012 01:05:46 +0000

libnss-cache (0.10.1-1) unstable; urgency=low

  * New upstream release.
  * Speeds up the name / uid / gid lookup in the nss-cache library.
    * don't search groups if the provided buffer is small enough that the
      chance of succeeding is small
    * create simple index structure with uniformly sized entries and
	  mmap/bsearch as a replacement for a heuristic binary search
    * if the entry was not found in the index, do not fall back to linear
      search; still fall back if the entry was outdated, not accessible or
      if a value was not found at the expected offset
    * replace strcoll with strcmp for checking equality of the index, as
	  the index is built based on a simple string sort

 -- Jamie Wilkinson <jaq@debian.org>  Fri, 10 Feb 2012 11:11:07 +1100

=== debian/control ===
Source: libnss-cache
Section: admin
Priority: optional
Maintainer: Jamie Wilkinson <jaq@debian.org>
Build-Depends: debhelper (>= 7.0.50), libc6-dev-i386 [amd64],
  libc6-dev-amd64 [i386], gcc-multilib | lib32gcc1 [amd64] | lib64gcc1 [i386]
Standards-Version: 3.8.4
Homepage: http://code.google.com/p/nsscache

Package: libnss-cache
# TODO(jaq): The makefile only supports these two arch's, and needs updating.
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: nsscache
Description: NSS module for using nsscache-generated files
 This package provides a Name Service Switch module that uses .cache
 files as a name service. This means providing user account
 information, group ids, netgroups, and automounts.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_build:
	$(MAKE) build_$(ARCH)

override_dh_install:
	$(MAKE) install_$(ARCH) DESTDIR=debian/libnss-cache/

override_dh_auto_test:


# Set our architecture here so we can build the 64bit libs
ARCH="`dpkg-architecture  -qDEB_HOST_ARCH`"

## libnss-cache 0.12

=== Makefile ===
CC=gcc
#CFLAGS=-Wall -Wstrict-prototypes -Werror -fPIC -DDEBUG -g -O0
CFLAGS=-Wall -Wstrict-prototypes -Werror -fPIC
LIBRARY=libnss_cache.so.2.0
BASE_LIBRARY=libnss_cache.so.2
PREFIX=$(DESTDIR)/usr
LIBDIR=$(PREFIX)/lib
SONAME=libnss_cache.so.2
LD_SONAME=-Wl,-soname,$(SONAME)
TESTDATA=.testdata

SOURCES = Makefile gen_getent.c lookup.c nss_cache.c nss_cache.h nss_test.h COPYING version libnss-cache.spec
VERSION = $(shell cat version)

all: $(LIBRARY)

check: test_getent time_lookups

lookup: lookup.o nss_cache.o
	$(CC) $(CFLAGS) -o $@ $^

time_lookups: testdirs lookup_data lookup
	@echo Linear username lookups
	rm -f $(TESTDATA)/passwd.cache.ixname
	time -f %E lookup -c getpwnam -f $(TESTDATA)/rand_pwnames
	@echo Binary username lookups
	../vendetta/files/gen_cache.py $(TESTDATA)/passwd.cache 1 $(TESTDATA)/passwd.cache.ixname
	time -f %E lookup -c getpwnam -f $(TESTDATA)/rand_pwnames
	@echo Linear UID lookups
	rm -f $(TESTDATA)/passwd.cache.ixuid
	time -f %E lookup -c getpwuid -f $(TESTDATA)/rand_pwuids
	@echo Binary UID lookups
	../vendetta/files/gen_cache.py $(TESTDATA)/passwd.cache 3 $(TESTDATA)/passwd.cache.ixuid
	time -f %E lookup -c getpwuid -f $(TESTDATA)/rand_pwuids
	@echo Linear groupname lookups
	rm -f $(TESTDATA)/group.cache.ixname
	time -f %E lookup -c getgrnam -f $(TESTDATA)/rand_grnames
	@echo Binary groupname lookups
	sort -t: -k1,1 $(TESTDATA)/group.cache > $(TESTDATA)/group.cache.ixname
	../vendetta/files/gen_cache.py $(TESTDATA)/group.cache 1 $(TESTDATA)/group.cache.ixname
	time -f %E lookup -c getgrnam -f $(TESTDATA)/rand_grnames
	@echo Linear GID lookups
	rm -f $(TESTDATA)/group.cache.ixgid
	time -f %E lookup -c getgrgid -f $(TESTDATA)/rand_grgids
	@echo Binary GID lookups
	../vendetta/files/gen_cache.py $(TESTDATA)/group.cache 3 $(TESTDATA)/group.cache.ixgid
	time -f %E lookup -c getgrgid -f $(TESTDATA)/rand_grgids
	@echo Linear shadow lookups
	rm -f $(TESTDATA)/shadow.cache.ixname
	time -f %E lookup -c getspnam -f $(TESTDATA)/rand_spnames
	@echo Binary shadow lookups
	../vendetta/files/gen_cache.py $(TESTDATA)/shadow.cache 1 $(TESTDATA)/shadow.cache.ixname
	time -f %E lookup -c getspnam -f $(TESTDATA)/rand_spnames

gen_getent: gen_getent.o nss_cache.o
	$(CC) -o $@ $^


test_getent: getent_data gen_getent.c nss_cache.c
	sudo gen_getent
	diff $(TESTDATA)/passwd.cache $(TESTDATA)/passwd.cache.out
	diff $(TESTDATA)/group.cache $(TESTDATA)/group.cache.out
	diff $(TESTDATA)/shadow.cache $(TESTDATA)/shadow.cache.out

lookup_data: getent_data
	cut -d : -f 1 $(TESTDATA)/passwd.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_pwnames
	cut -d : -f 3 $(TESTDATA)/passwd.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_pwuids
	cut -d : -f 1 $(TESTDATA)/group.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_grnames
	cut -d : -f 3 $(TESTDATA)/group.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_grgids
	cut -d : -f 1 $(TESTDATA)/shadow.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_spnames

getent_data: testdirs
	getent passwd > $(TESTDATA)/passwd.cache
	getent group > $(TESTDATA)/group.cache
	sudo getent shadow > $(TESTDATA)/shadow.cache

testdirs:
	mkdir -p $(TESTDATA)

$(LIBRARY): nss_cache.o
	$(CC) -shared $(LD_SONAME) -o $(LIBRARY) $<

clean:
	rm -f $(LIBRARY) *.o lookup gen_getent
	rm -rf $(TESTDATA)

install:
	install -d $(LIBDIR)
	install $(LIBRARY) $(LIBDIR)
	ln -sf $(LIBRARY) $(LIBDIR)/$(BASE_LIBRARY)

distclean: clean
	rm -f *~ \#*

dist:
	rm -rf libnss-cache-$(VERSION) libnss-cache-$(VERSION).tar libnss-cache-$(VERSION).tar.gz
	mkdir libnss-cache-$(VERSION)
	cp $(SOURCES) libnss-cache-$(VERSION)
	tar cf libnss-cache-$(VERSION).tar libnss-cache-$(VERSION)
	gzip -9 libnss-cache-$(VERSION).tar
	rm -rf libnss-cache-$(VERSION)

.PHONY: all dist clean install distclean

=== debian/changelog ===
libnss-cache (0.12-1~ubuntu14.04.1) trusty-backports; urgency=medium

  * No-change backport to trusty (LP: #1323161)

 -- Iain Lane <iain@orangesquash.org.uk>  Thu, 29 May 2014 08:27:53 +0100

libnss-cache (0.12-1) unstable; urgency=medium

  * New upstream release.  (Closes: #745258; thanks Arthur Marble). 
  * Ignore tarballs in debian/source/options. 

 -- Jamie Wilkinson <jaq@debian.org>  Thu, 22 May 2014 18:24:55 +1000

libnss-cache (0.11-2) unstable; urgency=low

  * Fix FTBFS with clang
    - Fixed the potential usage of an uninitialized variable error in
      nss_cache.c

 -- Arthur Marble <arthur@info9.net>  Sat, 19 Apr 2014 16:02:56 -0500

libnss-cache (0.11-1) unstable; urgency=medium

  * New upstream release.
  * Change to arch: any, now builds on all architectures. 
  * Update standards-version. 
  * Depend on new debhelper. 

 -- Jamie Wilkinson <jaq@debian.org>  Sun, 23 Mar 2014 16:55:37 +1100

=== debian/control ===
Source: libnss-cache
Section: admin
Priority: optional
Maintainer: Jamie Wilkinson <jaq@debian.org>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.5
Homepage: http://code.google.com/p/nsscache

Package: libnss-cache
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: nsscache
Description: NSS module for using nsscache-generated files
 This package provides a Name Service Switch module that uses .cache
 files as a name service. This means providing user account
 information, group ids, netgroups, and automounts.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_test:

=== debian/watch ===
version=3
http://code.google.com/p/nsscache/downloads/list .*/libnss-cache-(.*)\.tar\.gz debian

## libnss-cache 0.13

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
-CC=gcc
-#CFLAGS=-Wall -Wstrict-prototypes -Werror -fPIC -DDEBUG -g -O0
-CFLAGS=-Wall -Wstrict-prototypes -Werror -fPIC
+CC ?= gcc
+CFLAGS ?= -Wall -Wstrict-prototypes -Werror
+CFLAGS += -fPIC
+LDFLAGS += -shared
 LIBRARY=libnss_cache.so.2.0
 BASE_LIBRARY=libnss_cache.so.2
 PREFIX=$(DESTDIR)/usr
@@ -79,17 +80,20 @@
 	getent group > $(TESTDATA)/group.cache
 	sudo getent shadow > $(TESTDATA)/shadow.cache
 
+last_pw_errno_test: test/last_pw_errno_test.c
+	$(CC) $(CFLAGS) -o $@ $^
+
 testdirs:
 	mkdir -p $(TESTDATA)
 
 $(LIBRARY): nss_cache.o
-	$(CC) -shared $(LD_SONAME) -o $(LIBRARY) $<
+	$(CC) $(CFLAGS) $(LDFLAGS) $(LD_SONAME) -o $(LIBRARY) $<
 
 clean:
-	rm -f $(LIBRARY) *.o lookup gen_getent
+	rm -f $(LIBRARY) *.o lookup gen_getent last_pw_errno_test
 	rm -rf $(TESTDATA)
 
-install:
+install: all 
 	install -d $(LIBDIR)
 	install $(LIBRARY) $(LIBDIR)
 	ln -sf $(LIBRARY) $(LIBDIR)/$(BASE_LIBRARY)

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,10 @@
 Priority: optional
 Maintainer: Jamie Wilkinson <jaq@debian.org>
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://code.google.com/p/nsscache
+Vcs-Browser: https://github.com/google/libnss-cache/tree/debian
+Vcs-Git: https://github.com/google/libnss-cache -b debian
 
 Package: libnss-cache
 Architecture: any

## libnss-cache 0.14

=== debian/changelog ===
libnss-cache (0.14-1) unstable; urgency=medium

  * New upstream release. 

 -- Jamie Wilkinson <jaq@debian.org>  Wed, 20 May 2015 09:00:53 +1000

libnss-cache (0.13-1) unstable; urgency=medium

  * Update control file with VCS URLs. 
  * New upstream version.
  * Update watch file to match new github upstream.
  * Bump standards version.

 -- Jamie Wilkinson <jaq@debian.org>  Wed, 22 Oct 2014 10:41:44 +1100

## libnss-cache 0.15

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 CC ?= gcc
-CFLAGS ?= -Wall -Wstrict-prototypes -Werror
+CFLAGS ?= -Wall -Wstrict-prototypes
 CFLAGS += -fPIC
 LDFLAGS += -shared
 LIBRARY=libnss_cache.so.2.0
@@ -10,6 +10,8 @@
 LD_SONAME=-Wl,-soname,$(SONAME)
 TESTDATA=.testdata
 
+LIBNSSCACHE = nss_cache.o compat/getpwent_r.o compat/getgrent_r.o
+
 SOURCES = Makefile gen_getent.c lookup.c nss_cache.c nss_cache.h nss_test.h COPYING version libnss-cache.spec
 VERSION = $(shell cat version)
 
@@ -17,7 +19,7 @@
 
 check: test_getent time_lookups
 
-lookup: lookup.o nss_cache.o
+lookup: lookup.o $(LIBNSSCACHE)
 	$(CC) $(CFLAGS) -o $@ $^
 
 time_lookups: testdirs lookup_data lookup
@@ -53,7 +55,7 @@
 	../vendetta/files/gen_cache.py $(TESTDATA)/shadow.cache 1 $(TESTDATA)/shadow.cache.ixname
 	time -f %E lookup -c getspnam -f $(TESTDATA)/rand_spnames
 
-gen_getent: gen_getent.o nss_cache.o
+gen_getent: gen_getent.o $(LIBNSSCACHE)
 	$(CC) -o $@ $^
 
 
@@ -86,14 +88,14 @@
 testdirs:
 	mkdir -p $(TESTDATA)
 
-$(LIBRARY): nss_cache.o
-	$(CC) $(CFLAGS) $(LDFLAGS) $(LD_SONAME) -o $(LIBRARY) $<
+$(LIBRARY): $(LIBNSSCACHE)
+	$(CC) $(CFLAGS) $(LDFLAGS) $(LD_SONAME) -o $(LIBRARY) $+
 
 clean:
-	rm -f $(LIBRARY) *.o lookup gen_getent last_pw_errno_test
+	rm -f $(LIBRARY) *.o compat/*.o lookup gen_getent last_pw_errno_test
 	rm -rf $(TESTDATA)
 
-install: all 
+install: all
 	install -d $(LIBDIR)
 	install $(LIBRARY) $(LIBDIR)
 	ln -sf $(LIBRARY) $(LIBDIR)/$(BASE_LIBRARY)

## libnss-cache 0.16

=== debian/changelog ===
libnss-cache (0.16-3) unstable; urgency=medium

  * Add missing Multi-Arch header to debian/control. 

 -- Jamie Wilkinson <jaq@debian.org>  Mon, 07 Nov 2016 15:18:25 +1100

libnss-cache (0.16-2) unstable; urgency=medium

  * Bump standards version. 

 -- Jamie Wilkinson <jaq@debian.org>  Tue, 01 Nov 2016 16:04:27 +1100

libnss-cache (0.16-1) unstable; urgency=medium

  * New upstream release.

 -- Jamie Wilkinson <jaq@debian.org>  Tue, 01 Nov 2016 15:39:14 +1100

libnss-cache (0.15-2) unstable; urgency=medium

  * Fix nss.h include for BSD.

 -- Jamie Wilkinson <jaq@debian.org>  Wed, 30 Dec 2015 17:54:57 +1100

libnss-cache (0.15-1) unstable; urgency=medium

  * New upstream release.
  * Change obsolete homepage URL.

 -- Jamie Wilkinson <jaq@debian.org>  Wed, 30 Dec 2015 16:20:07 +1100

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Priority: optional
 Maintainer: Jamie Wilkinson <jaq@debian.org>
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.6
-Homepage: http://code.google.com/p/nsscache
+Standards-Version: 3.9.8
+Homepage: https://github.com/google/libnss-cache
 Vcs-Browser: https://github.com/google/libnss-cache/tree/debian
 Vcs-Git: https://github.com/google/libnss-cache -b debian
 
 Package: libnss-cache
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: nsscache
 Description: NSS module for using nsscache-generated files

=== debian/rules ===
--- 
+++ 
@@ -7,13 +7,18 @@
 # This special exception was added by Craig Small in version 0.37 of dh-make.
 
 # Uncomment this to turn on verbose mode.
-export DH_VERBOSE=1
+#export DH_VERBOSE=1
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+include /usr/share/dpkg/default.mk
+
+DESTDIR=$(CURDIR)/debian/libnss-cache
+LIBDIR=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
 
 %:
 	dh $@
 
+override_dh_auto_install:
+	mkdir -p $(LIBDIR)
+	dh_auto_install -- LIBDIR=$(LIBDIR)
+
 override_dh_auto_test:

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libnss-cache-$1\.tar\.gz/ \
  https://github.com/google/libnss-cache/tags .*/version\/(\d\S*)\.tar\.gz

## libnss-cache 0.17

=== Makefile ===
CC ?= gcc
CFLAGS ?= -Wall -Wstrict-prototypes
CFLAGS += -fPIC
LDFLAGS += -shared
LIBRARY=libnss_cache.so.2.0
BASE_LIBRARY=libnss_cache.so.2
PREFIX=$(DESTDIR)/usr
LIBDIR=$(PREFIX)/lib
SONAME=libnss_cache.so.2
LD_SONAME=-Wl,-soname,$(SONAME)
TESTDATA=.testdata

LIBNSSCACHE = nss_cache.o compat/getpwent_r.o compat/getgrent_r.o

SOURCES = Makefile gen_getent.c lookup.c nss_cache.c nss_cache.h nss_test.h COPYING version libnss-cache.spec
VERSION = $(shell cat version)

all: $(LIBRARY)

check: test_getent time_lookups

lookup: lookup.o $(LIBNSSCACHE)
	$(CC) $(CFLAGS) -o $@ $^

time_lookups: testdirs lookup_data lookup
	@echo Linear username lookups
	rm -f $(TESTDATA)/passwd.cache.ixname
	time -f %E ./lookup -c getpwnam -f $(TESTDATA)/rand_pwnames
	@echo Binary username lookups
	./scripts/index.sh $(TESTDATA)/passwd.cache 1 $(TESTDATA)/passwd.cache.ixname
	time -f %E ./lookup -c getpwnam -f $(TESTDATA)/rand_pwnames

	@echo Linear UID lookups
	rm -f $(TESTDATA)/passwd.cache.ixuid
	time -f %E ./lookup -c getpwuid -f $(TESTDATA)/rand_pwuids
	@echo Binary UID lookups
	./scripts/index.sh $(TESTDATA)/passwd.cache 3 $(TESTDATA)/passwd.cache.ixuid
	time -f %E ./lookup -c getpwuid -f $(TESTDATA)/rand_pwuids

	@echo Linear groupname lookups
	rm -f $(TESTDATA)/group.cache.ixname
	time -f %E ./lookup -c getgrnam -f $(TESTDATA)/rand_grnames
	@echo Binary groupname lookups
	./scripts/index.sh $(TESTDATA)/group.cache 1 $(TESTDATA)/group.cache.ixname
	time -f %E ./lookup -c getgrnam -f $(TESTDATA)/rand_grnames

	@echo Linear GID lookups
	rm -f $(TESTDATA)/group.cache.ixgid
	time -f %E ./lookup -c getgrgid -f $(TESTDATA)/rand_grgids
	@echo Binary GID lookups
	./scripts/index.sh $(TESTDATA)/group.cache 3 $(TESTDATA)/group.cache.ixgid
	time -f %E ./lookup -c getgrgid -f $(TESTDATA)/rand_grgids

	@echo Linear shadow lookups
	rm -f $(TESTDATA)/shadow.cache.ixname
	time -f %E ./lookup -c getspnam -f $(TESTDATA)/rand_spnames
	@echo Binary shadow lookups
	./scripts/index.sh $(TESTDATA)/shadow.cache 1 $(TESTDATA)/shadow.cache.ixname
	time -f %E ./lookup -c getspnam -f $(TESTDATA)/rand_spnames

gen_getent: gen_getent.o $(LIBNSSCACHE)
	$(CC) -o $@ $^


test_getent: getent_data gen_getent nss_cache.c
	./gen_getent
	diff $(TESTDATA)/passwd.cache $(TESTDATA)/passwd.cache.out
	diff $(TESTDATA)/group.cache $(TESTDATA)/group.cache.out
	diff $(TESTDATA)/shadow.cache $(TESTDATA)/shadow.cache.out

lookup_data: getent_data
	cut -d : -f 1 $(TESTDATA)/passwd.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_pwnames
	cut -d : -f 3 $(TESTDATA)/passwd.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_pwuids
	cut -d : -f 1 $(TESTDATA)/group.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_grnames
	cut -d : -f 3 $(TESTDATA)/group.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_grgids
	cut -d : -f 1 $(TESTDATA)/shadow.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_spnames

getent_data: testdirs
	./scripts/gentestdata.sh $(TESTDATA)

last_pw_errno_test: test/last_pw_errno_test.c
	$(CC) $(CFLAGS) -o $@ $^

testdirs:
	mkdir -p $(TESTDATA)

$(LIBRARY): $(LIBNSSCACHE)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LD_SONAME) -o $(LIBRARY) $+

clean:
	rm -f $(LIBRARY) *.o compat/*.o lookup ./gen_getent last_pw_errno_test
	rm -rf $(TESTDATA)

install: all
	install -d $(LIBDIR)
	install $(LIBRARY) $(LIBDIR)
	ln -sf $(LIBRARY) $(LIBDIR)/$(BASE_LIBRARY)

distclean: clean
	rm -f *~ \#*

dist:
	rm -rf libnss-cache-$(VERSION) libnss-cache-$(VERSION).tar libnss-cache-$(VERSION).tar.gz
	mkdir libnss-cache-$(VERSION)
	cp $(SOURCES) libnss-cache-$(VERSION)
	tar cf libnss-cache-$(VERSION).tar libnss-cache-$(VERSION)
	gzip -9 libnss-cache-$(VERSION).tar
	rm -rf libnss-cache-$(VERSION)

.PHONY: all dist clean install distclean


###
## CircleCI development targets
#

.PHONY: circleci-validate
circleci-validate: .circleci/config.yml
	circleci config validate

# Override this on the make command to say which job to run
CIRCLEJOB ?= build
.PHONY: circleci-execute
.INTERMEDIATE: tmpconfig.yml
circleci-execute: .circleci/config.yml circleci-validate
ifeq ($(CIRCLECI),true)
	$(error "Don't run this target from within CircleCI!")
endif
	circleci config process $< > tmpconfig.yml
	circleci local execute -c tmpconfig.yml --job $(CIRCLEJOB)

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
DPKG_EXPORT_BUILD_FLAGS=1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/default.mk

DESTDIR=$(CURDIR)/debian/libnss-cache
LIBDIR=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_install:
	mkdir -p $(LIBDIR)
	dh_auto_install -- LIBDIR=$(LIBDIR)

## libnss-cache 0.18

=== Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 LIBNSSCACHE = nss_cache.o compat/getpwent_r.o compat/getgrent_r.o
 
 SOURCES = Makefile gen_getent.c lookup.c nss_cache.c nss_cache.h nss_test.h COPYING version libnss-cache.spec
-VERSION = $(shell cat version)
+VERSION = $(shell git describe --tags --always | sed -E 's@.*/([^-]*).*@\1@')
 
 all: $(LIBRARY)
 
@@ -113,23 +113,3 @@
 	rm -rf libnss-cache-$(VERSION)
 
 .PHONY: all dist clean install distclean
-
-
-###
-## CircleCI development targets
-#
-
-.PHONY: circleci-validate
-circleci-validate: .circleci/config.yml
-	circleci config validate
-
-# Override this on the make command to say which job to run
-CIRCLEJOB ?= build
-.PHONY: circleci-execute
-.INTERMEDIATE: tmpconfig.yml
-circleci-execute: .circleci/config.yml circleci-validate
-ifeq ($(CIRCLECI),true)
-	$(error "Don't run this target from within CircleCI!")
-endif
-	circleci config process $< > tmpconfig.yml
-	circleci local execute -c tmpconfig.yml --job $(CIRCLEJOB)

=== debian/changelog ===
libnss-cache (0.18-2) unstable; urgency=medium

  * Set the build locale as C.UTF-8 to make the build reproducible.
  * Specify Rules-Requires-Root: no.
  * Bump debhelper-compat to 13.
  * Reformat copyright as dep5 machine readable.

 -- Jamie Wilkinson <jaq@debian.org>  Sat, 23 Oct 2021 17:31:32 +1100

libnss-cache (0.18-1) unstable; urgency=medium

  * New upstream release.
  * Remove local source options as unapply-patches is the default.
  * Update standards version to 4.5.1.
  * Update watch format version to 4.

 -- Jamie Wilkinson <jaq@debian.org>  Fri, 12 Feb 2021 16:42:04 +1100

libnss-cache (0.17-2) unstable; urgency=medium

  * Moved Debian packaging to salsa.debian.org; updated control.

 -- Jamie Wilkinson <jaq@debian.org>  Mon, 08 Feb 2021 12:42:19 +1100

libnss-cache (0.17-1) unstable; urgency=medium

  * New upstram release.
  * Trim trailing whitespace.
  * Bump debhelper from old 9 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Use canonical URL in Vcs-Git.
  * Update standards-version to 4.4.0.
  * Add build hardening flags.
  * Run the test suite now one exists.

 -- Jamie Wilkinson <jaq@debian.org>  Tue, 14 Jan 2020 16:08:39 +1100

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,14 @@
 Section: admin
 Priority: optional
 Maintainer: Jamie Wilkinson <jaq@debian.org>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.8
+Build-Depends: debhelper-compat (= 13),
+ dpkg-dev (>= 1.16.1.1~),
+ time
+Standards-Version: 4.5.1
 Homepage: https://github.com/google/libnss-cache
-Vcs-Browser: https://github.com/google/libnss-cache/tree/debian
-Vcs-Git: https://github.com/google/libnss-cache -b debian
+Vcs-Browser: https://salsa.debian.org/debian/libnss-cache
+Vcs-Git: https://salsa.debian.org/debian/libnss-cache.git
+Rules-Requires-Root: no
 
 Package: libnss-cache
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,9 @@
 DESTDIR=$(CURDIR)/debian/libnss-cache
 LIBDIR=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
 
+# Export locale for build system to run tests as
+export LC_ALL=C.UTF-8
+
 %:
 	dh $@

## libnss-cache 0.21

=== Makefile ===
CC ?= gcc
CFLAGS ?= -Wall -Wstrict-prototypes
CFLAGS += -fPIC
LIBRARY=libnss_cache.so
PREFIX=$(DESTDIR)/usr
LIBDIR=$(PREFIX)/lib
SONAME=libnss_cache.so.2
LD_SONAME=-Wl,-soname,$(SONAME)
TESTDATA=.testdata

LIBNSSCACHE = nss_cache.o compat/getpwent_r.o compat/getgrent_r.o

SOURCES = Makefile gen_getent.c lookup.c nss_cache.c nss_cache.h nss_test.h COPYING version libnss-cache.spec
VERSION = $(shell git describe --tags --always | sed -E 's@.*/([^-]*).*@\1@')

GETENT_DATA_TOUCH = $(TESTDATA)/.touch.getent_data
LOOKUP_DATA_TOUCH = $(TESTDATA)/.touch.lookup_data
INDEX_DATA_TOUCH = $(TESTDATA)/.touch.index_data

.PHONY: all
all: $(LIBRARY)

.PHONY: test
test: test_getent time_lookups

.PHONY: check
check: CFLAGS += -O0 -g --coverage
check: LDFLAGS += --coverage
check: test_getent time_lookups

lookup: lookup.o $(LIBNSSCACHE)

.PHONY: time_lookups
time_lookups: lookup_data index_data lookup
	@echo Linear username lookups
	rm -f $(TESTDATA)/passwd.cache.ixname
	time -f %E ./lookup -c getpwnam -f $(TESTDATA)/rand_pwnames
	@echo Binary username lookups
	ln -sf passwd_cache_ixname_disabled $(TESTDATA)/passwd.cache.ixname
	time -f %E ./lookup -c getpwnam -f $(TESTDATA)/rand_pwnames
	@echo Linear UID lookups
	rm -f $(TESTDATA)/passwd.cache.ixuid
	time -f %E ./lookup -c getpwuid -f $(TESTDATA)/rand_pwuids
	@echo Binary UID lookups
	ln -sf passwd_cache_ixuid_disabled $(TESTDATA)/passwd.cache.ixuid
	time -f %E ./lookup -c getpwuid -f $(TESTDATA)/rand_pwuids
	@echo Linear groupname lookups
	rm -f $(TESTDATA)/group.cache.ixname
	time -f %E ./lookup -c getgrnam -f $(TESTDATA)/rand_grnames
	@echo Binary groupname lookups
	ln -sf group_cache_ixname_disabled $(TESTDATA)/group.cache.ixname
	time -f %E ./lookup -c getgrnam -f $(TESTDATA)/rand_grnames
	@echo Linear GID lookups
	rm -f $(TESTDATA)/group.cache.ixgid
	time -f %E ./lookup -c getgrgid -f $(TESTDATA)/rand_grgids
	@echo Binary GID lookups
	ln -sf group_cache_ixuid_disabled $(TESTDATA)/group.cache.ixuid
	time -f %E ./lookup -c getgrgid -f $(TESTDATA)/rand_grgids
	@echo Linear shadow lookups
	rm -f $(TESTDATA)/shadow.cache.ixname
	time -f %E ./lookup -c getspnam -f $(TESTDATA)/rand_spnames
	@echo Binary shadow lookups
	ln -sf shadow_cache_ixname_disabled $(TESTDATA)/shadow.cache.ixname
	time -f %E ./lookup -c getspnam -f $(TESTDATA)/rand_spnames
	@echo Linear gshadow lookups
	rm -f $(TESTDATA)/gshadow.cache.ixname
	time -f %E ./lookup -c getsgnam -f $(TESTDATA)/rand_sgnames
	@echo Binary gshadow lookups
	ln -sf gshadow_cache_ixname_disabled $(TESTDATA)/gshadow.cache.ixname
	time -f %E ./lookup -c getsgnam -f $(TESTDATA)/rand_sgnames
	gcov --all-blocks --branch-probabilities --branch-counts --function-summaries --unconditional-branches ./lookup

gen_getent: gen_getent.o $(LIBNSSCACHE)


.PHONY: test_getent
test_getent: getent_data gen_getent nss_cache.c
	./gen_getent
	diff $(TESTDATA)/passwd.cache $(TESTDATA)/passwd.cache.out
	diff $(TESTDATA)/group.cache $(TESTDATA)/group.cache.out
	diff $(TESTDATA)/shadow.cache $(TESTDATA)/shadow.cache.out
	diff $(TESTDATA)/gshadow.cache $(TESTDATA)/gshadow.cache.out
	gcov --all-blocks --branch-probabilities --branch-counts --function-summaries --unconditional-branches ./gen_getent


.PHONY: index_data
index_data: $(INDEX_DATA_TOUCH)

$(INDEX_DATA_TOUCH): $(LOOKUP_DATA_TOUCH)
	./scripts/index.sh $(TESTDATA)/passwd.cache  1 $(TESTDATA)/passwd_cache_ixname_disabled
	./scripts/index.sh $(TESTDATA)/passwd.cache  3 $(TESTDATA)/passwd_cache_ixuid_disabled
	./scripts/index.sh $(TESTDATA)/group.cache   1 $(TESTDATA)/group_cache_ixname_disabled
	./scripts/index.sh $(TESTDATA)/group.cache   3 $(TESTDATA)/group_cache_ixgid_disabled
	./scripts/index.sh $(TESTDATA)/shadow.cache  1 $(TESTDATA)/shadow_cache_ixname_disabled
	./scripts/index.sh $(TESTDATA)/gshadow.cache 1 $(TESTDATA)/gshadow_cache_ixname_disabled

.PHONY: lookup_data
lookup_data: $(LOOKUP_DATA_TOUCH)

$(LOOKUP_DATA_TOUCH): $(GETENT_DATA_TOUCH)
	cut -d : -f 1 $(TESTDATA)/passwd.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_pwnames
	cut -d : -f 3 $(TESTDATA)/passwd.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_pwuids
	cut -d : -f 1 $(TESTDATA)/group.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_grnames
	cut -d : -f 3 $(TESTDATA)/group.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_grgids
	cut -d : -f 1 $(TESTDATA)/shadow.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_spnames
	cut -d : -f 1 $(TESTDATA)/gshadow.cache |\
	  sort -R | head -500 > $(TESTDATA)/rand_sgnames
	touch $@

.PHONY: getent_data
getent_data: $(GETENT_DATA_TOUCH)

$(GETENT_DATA_TOUCH): scripts/gentestdata.sh
	mkdir -p $(TESTDATA)
	./scripts/gentestdata.sh $(TESTDATA)
	touch $@

last_pw_errno_test: test/last_pw_errno_test.c

$(LIBRARY): LDFLAGS += -shared $(LD_SONAME)
$(LIBRARY): $(LIBNSSCACHE)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $(LIBRARY) $+

$(SONAME): $(LIBRARY)
	ln -sf $(LIBRARY) $(SONAME)
	ln -sf $(LIBRARY) $(SONAME).0

.PHONY: install
install: $(SONAME)
	install -d $(LIBDIR)
	install $(LIBRARY) $(LIBDIR)
	install $(SONAME) $(LIBDIR)
	install $(SONAME).0 $(LIBDIR)

.PHONY: clean
clean:
	rm -f $(LIBRARY)* *.o compat/*.o *.gcov *.gcda *.gcno compat/*.gcda compat/*.gcno lookup gen_getent last_pw_errno_test

.PHONY: veryclean
veryclean: clean
	rm -rf $(TESTDATA)

.PHONY: distclean
distclean: veryclean
	rm -f *~ \#*

.PHONY: dist
dist:
	rm -rf libnss-cache-$(VERSION) libnss-cache-$(VERSION).tar libnss-cache-$(VERSION).tar.gz
	mkdir libnss-cache-$(VERSION)
	cp $(SOURCES) libnss-cache-$(VERSION)
	tar cf libnss-cache-$(VERSION).tar libnss-cache-$(VERSION)
	gzip -9 libnss-cache-$(VERSION).tar
	rm -rf libnss-cache-$(VERSION)

=== debian/changelog ===
libnss-cache (0.21-1) unstable; urgency=medium

  [ Jamie Wilkinson ]
  * Fix the license in debian/copyright.
  * lint: Override two findings for shared libraries.
  * Make sure the test code is compiled with correct coverage flags.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

 -- Jamie Wilkinson <jaq@debian.org>  Fri, 18 Aug 2023 14:37:23 +1000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: optional
 Maintainer: Jamie Wilkinson <jaq@debian.org>
 Build-Depends: debhelper-compat (= 13),
- dpkg-dev (>= 1.16.1.1~),
  time
 Standards-Version: 4.5.1
 Homepage: https://github.com/google/libnss-cache

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libnss-cache-$1\.tar\.gz/ \
  https://github.com/google/libnss-cache/tags .*/version\/(\d\S*)\.tar\.gz

## libnss-cache 0.22

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,9 @@
 CC ?= gcc
 CFLAGS ?= -Wall -Wstrict-prototypes
 CFLAGS += -fPIC
-LIBRARY=libnss_cache.so
+LIBRARY=libnss_cache.so.2
 PREFIX=$(DESTDIR)/usr
 LIBDIR=$(PREFIX)/lib
-SONAME=libnss_cache.so.2
-LD_SONAME=-Wl,-soname,$(SONAME)
 TESTDATA=.testdata
 
 LIBNSSCACHE = nss_cache.o compat/getpwent_r.o compat/getgrent_r.o
@@ -20,13 +18,10 @@
 .PHONY: all
 all: $(LIBRARY)
 
-.PHONY: test
-test: test_getent time_lookups
-
-.PHONY: check
-check: CFLAGS += -O0 -g --coverage
-check: LDFLAGS += --coverage
-check: test_getent time_lookups
+.PHONY: test check
+test check: CFLAGS += -O0 -g --coverage
+test check: LDFLAGS += --coverage
+test check: test_getent time_lookups
 
 lookup: lookup.o $(LIBNSSCACHE)
 
@@ -122,24 +117,18 @@
 
 last_pw_errno_test: test/last_pw_errno_test.c
 
-$(LIBRARY): LDFLAGS += -shared $(LD_SONAME)
+$(LIBRARY): LDFLAGS += -shared
 $(LIBRARY): $(LIBNSSCACHE)
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $(LIBRARY) $+
 
-$(SONAME): $(LIBRARY)
-	ln -sf $(LIBRARY) $(SONAME)
-	ln -sf $(LIBRARY) $(SONAME).0
-
 .PHONY: install
-install: $(SONAME)
+install: $(LIBRARY)
 	install -d $(LIBDIR)
 	install $(LIBRARY) $(LIBDIR)
-	install $(SONAME) $(LIBDIR)
-	install $(SONAME).0 $(LIBDIR)
 
 .PHONY: clean
 clean:
-	rm -f $(LIBRARY)* *.o compat/*.o *.gcov *.gcda *.gcno compat/*.gcda compat/*.gcno lookup gen_getent last_pw_errno_test
+	rm -f $(LIBRARY) *.o compat/*.o *.gcov *.gcda *.gcno compat/*.gcda compat/*.gcno lookup gen_getent last_pw_errno_test
 
 .PHONY: veryclean
 veryclean: clean

=== debian/changelog ===
libnss-cache (0.22-1) unstable; urgency=medium

  * New upstream release.
  * Fix lintian override.

 -- Brendan O'Dea <bod@debian.org>  Thu, 05 Dec 2024 15:10:44 +1100

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Jamie Wilkinson <jaq@debian.org>
+Uploaders: Brendan O'Dea <bod@debian.org>
 Build-Depends: debhelper-compat (= 13),
  time
 Standards-Version: 4.5.1
